= Release 2.12.0 =
Released: 2021-03-31

== Changes ==
 * Fixed issue #3631: Log: filtering commits by file path does not work if slash is used as path separator
   The Log Dialog now uses only the Git path (with slashes) for filtering. This is now consistent with other path filters in TortoiseGit.
 * Ctrl+Enter is assigned for the default button (Start Rebase, Amend, Commit, or Done) in the Rebase/Cherry-Pick dialog. This is now consistent with the Commit dialog.

== Features ==
 * Fixed issue #3654: Allow to completely disable the turtle animation, added TortoiseGit advanced setting "DownloadAnimation"
 * Update libgit to 2.30.2 based on Git for Windows sources
 * Update libgit2 to 1.1.0
 * Update Scintilla to 4.4.6
 * Allow multiple ref selection in the Revision Graph Filter
 * Move prune (all remotes) setting to git config page
 * Update pcre2 to 10.36
 * Fixed issue #3693: Make short hash length for hyper-link in log message configurable
 * Fixed issue #3705: No "Move to Changelist" option in check for modifications dialog
 * Fixes issue #3695: Keep the current line in the view when resizing with line-wrap on in TortoiseGitMerge
 * Switch dialog: Remember last state of the "Create New branch" checkbox state for switching to a tag or commit
 * Fixed issue #3181: Branch dialog: Create branch should remember "switch to" state
 * Fixed issue #3700: Resolve the conflicts did not show the merge_head with correct branch name
   The branch detection heuristic can now be disabled using the advanced setting "ConflictDontGuessBranchNames".

== Bug Fixes ==
 * Fixed issue #3649: "multi-project pull/fetch/push" not working
 * Fixed issue #3652: Clone: Auto fill from clipboard with URLs with quotes fails
 * Fixed issue #3651: View Patch window shrinks each time it opens with high DPI
 * TortoiseGitMerge: Make column index 1 based as most editors are 1-based instead of instead of 0 based
 * Fixed issue #3662: LogDlg: The "Compare change sets" command is not shown when two commits are adjacent on the list
 * Fixed issue #3664: revert dialog in dark mode shows file list black
 * Fixed issue #3668: "Revert to revision" fails for added files
 * Fixed issue #3678: Remove deprecated git lfs clone option from clone dialog
 * Fixed issue #3674: Missing "Add to ignore list" menu on the "Show Log" dialog
 * Fixed issue #3517: Revision graph filter does not work
 * Fixed issue #3685: The entered message erased by Amend Last Commit checkbox cannot be retrieved
 * Fixed issue #3686: Explorer hangs on dead network drives
 * Fixed issue #3696: Compare dialog (FileDiffDlg.cpp) should hide files with only ignored changes
 * Fixed issue #3704: Changed Files Dlg: "Revert to revision" fails for renamed files
 * Fixed issue #3694: No overlay if not all lower case in repo top folder in WSL2 filesystem

= Release 2.11.0 =
Released: 2020-10-10

== Bug Fixes ==
 * Fixed issue #3593: Statistics dialog - misaligned controls
 * Fixed issue #3598: TGitCache blocks repository directory to be truly deleted
 * Fixed issue #3619: Hook settings always reset "Hide the script while running" to checked for hooks stored in .tgitconfig
 * Fixed issue #3617: 'Saving config failed (key: "fetch.prune", value: "")' in remote repository definition when `fetch.prune` is set in global config
 * Fixed issue #3632: Log dialog: Message box with the text "git_get_commit_from_hash failed for 00...00" appears in certain situations
 * Fixed issue #3638: Better handling of trying to set an upstream branch not set to be fetched in the remote

== Features ==
 * Update Scintilla to 4.4.5
 * Fixed issue #3348: Showing line and column number in the status line of TortoiseGitMerge
 * Fixed issue #3408: TortoiseGitMerge: When double clicking on a word, mark the word only in the current view if also the Ctrl key is pressed
 * TortoiseGitMerge: Show the number of marked words in the status bar
 * Fixed issue #2101: Tortoise(Git)Merge - 'find' workflow suggested enhancement: Add "Search next" and "Search previous" to the ribbon
 * Fixed issue #3568: Add support for Git repository version 1
 * Fixed issue #3605: TortoiseGitProc branch command is not documented and does not handle /name parameter
 * Update pcre2 to 10.35
 * Fixed issue #3589: Added dark mode support to all TortoiseGit tools, needs to be separately enabled
   Dark mode can only be enabled for Windows 10 1809 and later when Windows dark mode is activated.
   This also improves the high contrast mode.
 * Allow to diff a file in Log/RepositoryBrowser with file selected by "Diff later" in Explorer
 * Fixed issue #3362: Ease searches in the log window (auto select text)
 * Fixed issue #3539: doesn't abort commit if user doesn't modify the template commit message
 * Fixed issue #3233: Change the dialog font to "Segoe UI", which is the default font for most Windows dialogs, including Explorer
 * Fixed issue #1274: Allow log font to be used for LogListCtrl and FileListCtrl
   Needs to be enabled explicitly in TortoiseGit advanced settings using LogFontForFileListCtrl resp. LogFontForLogCtrl
 * Fixed issue #3282: Prefs and Docs - UDiff should have a link back to Diff Viewer section
 * Update TortoiseGitPlink to PuTTY Plink 0.74
 * Update shipped PuTTY binaries to 0.74
 * Update libgit2 to 1.0
 * Implement very simple multi-project pull/fetch/push
 * Fixed issue #3183: Add support for git lfs lock/unlock
 * Fixed issue #3636: Commit Window new branch should focus textbox
 * Fixed issue #3312: Add --push-option to push dialog
 * Fixed issue #3641: Remove default behavior to create a branch when switching to a tag

= Release 2.10.0.2 =
Released: 2020-03-24

== Bug Fixes ==
 * Fixed issue #3557: TortoiseGitMerge 'Use this text block' not working
 * Fixed issue #3559: TortoiseGitMerge loses text selection when you open the context menu by right-clicking
 * Build with VS2019 16.4 again to circumvent code-gen-issues

= Release 2.10.0.1 =
Released: 2020-03-19

== Bug Fixes ==
 * Fixed issue #3525: LogDlg crashes on copying full log info
 * Fixes issue #3527: TGit always crashes when commiting an edit after opening the "Onto" dialog
 * LogDlg: Improve high contrast mode switching
 * Fixed issue #3535: `Show log ID instead of SHA-1` might cut of numbers
 * Fixed issue #3531: TortoiseGitMerge: the captured to clipboard text is two characters shorter than the selected
 * Fixed issue #3543: Push can't run TortoiseGitPlink.exe with Cygwin hack enabled
 * Fixed issue #3542: Commit many files not working with Cygwin hack enabled
 * Fixed issue #3524: Revision Graph very slow after update to 2.10.0.0
 * Fix possible crash on Git credential helper settings page
 * Fixed possible data races in sync dialog

= Release 2.10.0 =
Released: 2020-03-01

== Features ==
 * Fixed issue #3448: Revision Graph: Make direction of arrows configurable
 * Fixed issue #3263: Compare parent revision with working tree
 * Update Scintilla to 4.2.3
 * Update libgit2 to 0.99
 * Fixed issue #3481: Add Switch/Checkout to Tags and Refs in Revision Graph
 * TGitCache: Cache libgit2 config (reduce disk access)
 * The Setting "Use .mailmap" is now honored everywhere in TortoiseGit (e.g., TotoiseGitBlame, GitWCRev)
 * Enable Mailmap by default (Git 2.23 also enabled it by default)
 * Fixed issue #3494: External Merge tool trustExitCode
   An external merge tool can now be executed synchronous (ie, TortoiseGit blocks while it's running): After the exit of the merge tool TortoiseGit automatically removes the temporary files and asks whether to mark the conflict as resolved.
 * Fixed issue #3470: Be able to switch branch from the Sync dialog
 * FileDiffDlg: Add patch dialog
 * Improved UDiff search
 * PullFetchDlg: Allow to select remote references (using ls-remote)
 * Add optional support for the Windows 8+ spell checker (needs to be enabled in Advanced Settings using the key "Win8SpellChecker" at the moment; if enabled it will be tried first, cf. manual)
 * Speed up RebaseDlg and SyncDlg by asynchronously calculating the file diff
 * Update libgit to 2.25.1 based on Git for Windows sources
 * Fixed issue #3452: Mouse wheel scroll does not work when mouse over author names in TortoiseGitBlame
 * Performance optimizations
 * Build with Visual Studio 2019

== Bug Fixes ==
 * Fixed issue #3449: Crash when indenting short lines (pressing tab key)
 * Fixed issue #3463: Check For Updates dialog - misaligned buttons
 * Fixed issue #3442: Commit & Push after amending a commit always results in a failed push
 * Fixed issue #3451: Turtle progress bar in process, but task is finish
 * Fixed issue #3450: Commit message after "Revert changes by these commits" suggests a single commit is reverted
 * Fixed issue #3461: Performing refresh on Commit window loses new branch name
 * Fixed issue #3446: No TortoiseGit Icon Overlays / Symbols in Drive Root Dir
 * Mark SSHAskPass and TortoiseGitPlink as DPIAware
 * PatchViewDlg: Fix Windows 10 border issue
 * Allow Refbrowser and Reflog to be minimized
 * Fixed issue #3480: Copy options in RefLog are misleading
 * Fixed issue #3497: Settings/Saved Data/URL-History/Del doesn't remove PUSH URLs:
 * Fixed issue #3466: Rebase checkboxes might disappear when resizing
 * Fixed issue #3493: Closing (cancelling) commit selection window while merging minimizes the Merge dialog
 * Fixed issue #3417: "ignore-on-commit" changelist disappears when committing on different folder
 * High DPI fixes (e.g., searchbar height/position in UDiff; remembering of dialog/slider/divider positions and column widths with changing DPI scalings)
 * LogDlg: Fix flickering on filtering
 * Fixed issue #3505: TortoiseGitProc and TGitCache crash on repositories with broken core.worktree path
 * SSHAskPass: Adjust window to text size
 * Fixed issue #3386: Line column in TortoiseGitUDiff might get cut off
 * Fixed issue #3454: Misaligned controls in Log Messages dialog

= Release 2.9.0 =
Released: 2019-10-31

== Changes ==
 * Support for Thesaurus was dropped
 * Thin-Pack option was dropped from fetch/pull dialog (enabled by default in Git)

== Features ==
 * Fixed issue #3355: Adding file name extension in the Export dialog
 * Update Scintilla to 4.2.0
 * Update libgit to 2.22.0 based on Git for Windows sources
 * Update TortoiseGitPLink to PuTTY PLink 0.73 (security fix, cf. https://www.chiark.greenend.org.uk/~sgtatham/putty/changes.html)
 * Update PuTTY binaries to 0.72
 * Allow to disable "Working Tree Changes" in log dialog (using advanced settings)
 * Update Hunspell to 1.7.0
 * Fixed issue #3363: Add option to show unlabeled most recent common ancestor between all branches in Revision Graph
   In the View menu you can now toggle the display of branchings and mergings.
   (This also fixes issue #2110: The Revision Graph is invalid if first commit does not contains the files)
 * Fixed issue #3379: Super-project-pointer should show in revision graph of submodule
 * Fixed issue #3421: Option to show Log IDs instead of SHA-1 in TortoiseGitBlame
 * Fixed issue #3343: Provide a confirm dialog instead of executing the revert operation directly
 * Ref Browse: Show date and author of annotated tag as well
 * Show whitespaces in patch views
 * Fixed issue #3414: Allow users to not display all tags on revision graph
 * Add find functionality to revision graph
 * Fixed issue #3427: FileDiffDlg: Provide a way to view the diff for a pull request branch (in diff options)
 * Fixed issue #3440: (GUI) Animation should stop when finished, not halt
 * Fixed issue #3395: TortoiseGit now uses the Windows "Default Application" framework for managing file associations and protocol handlers
 * Fixed issue #3436: Please document rolling back a file to a previous revision in Undo Changes

== Bug Fixes ==
 * Implement generic fix for "libgit2 returned the requested type does not match the type in ODB"
 * Fixed issue #3342: Windows Explorer context menu: TortoiseGit doesn't recognize local Git working copy if "gitdir-redirection" is used within same folder
 * Fixed issue #3349: View patch missing color
 * Fixed issue #3365: Ignore items by extension handles files/directories with no extension poorly
 * Fixed issue #3393: TortoiseGitIDiff crashes with a very small window size
 * Fixed issue #3397: Create Repository make a useless symlink on Windows 10
 * Fixed issue #3413: Putty Agent (pageant) unable to start when file "C:\Program" exists
 * Fixed issue #3429: Optimize progress output with multiple git commands
 * Fixed issue #3434: Commit dialog's "View Patch>>" shows nothing when dialog's right border is on the screen's right border
 * Fix potential crashes in TortoiseGitBlame when .mailmap support was enabled
 * Fix potential crash when log is still calculating diffs and rebase dialog loads
 * Prevent possible crash after rebase when writing to reflog fails
 * Fixed issue #3426: Ref Browse: Speed up display when having thousands of refs
 * TortoiseGitMerge: When ignoring comments in TMerge, ignore comment block markers inside strings
 * Fix start commit hook not working for repository hooks
 * Fix potential crashes when log is still loading and submodule diff is requested

= Release 2.8.0 =
Released: 2019-02-28

== Features ==
 * Update libgit to 2.19.0 based on Git for Windows sources
 * Fixed issue #2591: Enable accent coloring for search term matches in log messages and FileDiffDlg
 * LogDlg, FileDiffDlg, RefBrowserDlg: Allow to use more complex search expressions, see documentation
 * Fixed issue #3279: Browse References -> lacks capability to double click an item (now opens log by default)
 * Update Scintilla to 4.1.3
 * Fixed issue #3277: Start of rebase process doesn't show log tab by default
 * Fixed issue #3273: Show more information (beginning of commit subject) about commit parents in context menus
 * Fixed issue #3272: Revision Graph does not show the option to checkout a remote branch
 * Added the option to store hook configurations within the repository (/.tgitconfig) in order to share it with other developers
 * Fixed issue #3154: Decorate bare repository's folder with a Git icon
 * Update OGDF library to latest stable version (used for Revision Graph)
 * Make unified patch in temp folder read-only
 * Update apr to 1.6.5
 * Update libgit2 to version 0.28
 * Fixed issue #3304: Double click on stash list item does nothing, show log instead
 * Fixed issue #3305: Stash Changes/Save, then allow Stash Apply
 * Support opportunistic TLS for SendMailDlg
 * Improve documentation for alternative unified diff viewer configuration
 * TGitCache: Speed up scanning of folders with lots of unversioned files
 * BrowseRefsDlg: Allow to delete multiple remote branches in batch
 * Rebase: Document start, abort and finish in reflog 
 * Add TortoiseGitUDiff to Open With list
 * Update editorconfig to 0.12.4
 * Fixed issue #3295: TortoiseGitPlink does not work with Git protocol ver. 2
 * Fixed issue #3290: Improve "Status/Check for modifications" documentation
 * Fixed issue #3228: Rebase: Add full support for empty commits (e.g., commits which become empty during conflict resolution)
 * Fixed issue #3189: Show progress bar when resolving lots of conflicts
 * Fixed issue #3318: More accurate git-svn detection
 * Fixed issue #1770: Add support for changelists
 * Fixed issue #3327: Clarify remote and remote-tracking branch
 * TGitCache: Significantly reduce disk access for requesting cached file statuses
 * FileDiffDlg: Correctly show renames (also also allow to filter by them)
 * Fixed issue #3206: Update shipped Notepad2 to Notepad2e

== Bug Fixes ==
 * Fixed issue #3250: GitWCRev: IsGitItem return true for item that had never been committed
 * Fixed issue #3251: GitWCRev.GetWCInfo COM object ignores file path (parameter 1)
   GitWCRev not honours the passed path and calculates the HasModifications/UnversionedFiles status according to the passed path
 * Fixed issue #3261: Review/Apply single patch does not work anymore if patch does not apply cleanly
 * Fixed issue #2541: Patches created from "Create patch file" in diff view/TortoiseGitMerge has invalid filepath
 * CommitDlg: commit.template did not honor "~/"
 * Fixed issue #3271: Document TortoiseGitProc.exe /command:merge /abort option
 * Fixed issue #3281: TortoiseGitUDiff preferences page clips out text in Russian translation
 * Fixed issue #3284: BrowseRefsDlg: Cannot compare annotated tag to working tree (libgit2 returned the requested type does not match the type in ODB)
 * Modified files, Revert, and Resolve dialogs did show all staged files regardless of selection
   The Commit dialog still shows all staged files, this is by design and required for commit to work properly (e.g., that no files get lost in a merge commit).
 * Fixed issue #3264: Remove tag can leave an empty folder in refs/tags
 * Fixed issue #3297: Missing URI-encode of %BUGID%-part by call of issue tracker URL
 * Fixed issue #3307: Abort Merge on a single file always results in a parameter error message
 * Fixed issue #3269: Git Command Progress window blank, hanging on commit (e.g., when auto gc is running)
 * Fixed issue #3039: Icon overlays don't update properly when committing after gc prune on the command line
 * Fixed issue #3316: Misleading message box after pull with rebase, when branch is behind origin/branch, but origin/branch=remote/origin/master
 * Fixed issue #3288: Commit window: text is cut when Russian localisation
 * Fixed issue #3317: merge-ods.vbs-script: Merged document in LibreOffice 6.1 deleted by the script
 * Fixed issue #3329: create tag with message results in fatal error if username contains space
 * Fixed issue #3330: Edit notes don't load correctly for stash commits and reflog dialog
 * Fixed issue #3331: "Putty Key:" label is too narrow for localization
 * RefLog: Remember last selected branch on refresh
 * Opening the credential helper settings page caused elevation logic to trigger
 * Improved detection of valid git repositories
 * Improved stability in various unusual cases

= Release 2.7.0 =
Released: 2018-08-19

== Changes ==
 * Git (for Windows) 2.11 or newer is now required

== Features ==
 * Fixed issue #3186: Bisect skip missing on dialogs and in automation and bisect docs
 * Fixed issue #3188: Add progress support for submodule clone
 * Fixed issue #3212: With Detached Head, Push Dialog has Local Branch filled with HEAD or Commit Hash
 * Fixed issue #3223: Format Patch: Set From and To for single commits
 * Lots of high DPI improvements
 * Fixes issue #2635: The font of git log is too small
 * Fixed issue #3240: Allow changing the similarity index threshold (using the advanced option "DiffSimilarityIndexThreshold")
 * Fixed issue #3227: Add support to git describe option --first-parent
 * Fixed issue #3187: Assume unchanged for submodule directory can't be undone in TGit
 * SyncDlg: Allow to open the separate dialog boxes for fetch, pull, push, stash changes and submodule update/sync when holding the shift key when clicking on the buttons

== Bug Fixes ==
 * Fixed issue #3167: Crash when aborting cherry-picks
 * Fixed issue #3164: TortoiseGit crashing on commit (with racy git situation and git lfs)
 * Fixed issue #2035: Can not un-check the menu item "Abort Merge" in Settings dialog
 * Fixed issue #3078: Faulty behaviour of "Commit" feature in "check for modifications"
 * Fixed issue #3184: Committing asks for user data although they are set via includeif
 * Fixed issue #3193: Not able to set alternative editor
 * Fixed issue #3195: TGitMerge tool is not saving color to correct Windows registry location
 * Fixed issue #3194: Commit message control launches links on selection
 * Fixed issue #3202: Deletion of inactive branch inside not main working copy fails
 * Fixed issue #3200: Problem when adding files to a worktree which is based on a bare repo
 * Fixed issue #3201: Frequent TGitCache crashes
 * Fixed issue #3197: Bad generated path while renaming file with changing folder
 * Fixed issue #3211: Push from detached head not possible when no local branch exists
 * Fixed issue #3210: index.lock left behind after refreshing working tree changes when using Git LFS
 * Fixed issue #3234: Shortcuts for Up/Down still work while rebasing
 * Fixed issue #3239: Properly indicate processing in diff dialog
 * Fixed an regression which caused a major slowdown in TGitCache in repos with lots of unversioned files

= Release 2.6.0 =
Released: 2018-02-17

This is planned to be the last version compatible with MsysGit 1.9.5 (i.e., Git for Windows < 1.9.5).

== Features ==
 * Fixed issue #3089: Show parent SHA1 on cherry picking a merge commit
 * Fixed issue #3052: Filename autocomplete in commit dialog ignores filenames starting with underscores
 * TortoiseGitMerge now uses native ribbon instead of MFC wrapped
   This results in a noticeable speed up (cf. issue #1616) and also fixes issues with rounded corners for maximized windows (cf. issue #1767)
 * Fixed issue #3107: Clean: Allow to remove orphaned submodules (i.e., clean -f -f)
 * Fixed issue #3126: Add an option to show all refs of a commit in the log (all refs are shown now by default)
 * Fixed issue #3116: Revision graph: add ability to delete branches
 * Fixed issue #3121: Create shorter branch names when checking out a commit
 * Update linked libraries:
   * pcre to 8.41
   * apr to 1.6.3 and apr-util to 1.6.1
 * Commit now informs the user if there is a conflict hint in the commit message (line starting with "# Conflicts:")
 * Fixed issue #3137: Add TortoiseGit to Win10 default program list
 * Fixed issue #3141: bisect: add good/bad continue options to progress dialog
 * Add support for github's new client protocol (x-github-client)
 * Fixed issue #3160: Close TortoiseGitBlame window by ESC key (you might need to reset keyboard shortcut settings manually)

== Bug Fixes ==
 * Fixed issue #3029: LogDlg: Action column icons painted over Graph or message columns when turned off or resized
 * Fixed issue #3042: Spelling and grammar errors in First Start Wizard
 * Fixed issue #3035: TortoiseGit 2.5.0.0 might crash in LogDlg after fetch or refreshing working tree status
 * Fixed issue #3050: TortoiseGitMerge UI: Context menu is not available on margin left to text any more
 * Fixed issue #3059: Right click in touch mode is not working
 * Fixed issue #3064: Commit dialog ignores "Select items automatically" when refreshing
 * Fixed issue #3036: Can not save changes in Settings -> Network after trying to add command-line option to the SSH-client
 * Fixed issue #3066: Message field needs vertical scrollbar in Create Tag dialog
 * Fixed issue #3033: Cannot view submodule log if repository sits under directory symlink
   Update libgit to 2.15 based on Git for Windows source.
 * Fixed issue #3055: Explorer crash when deleting two independent folders
 * Fixed issue #3047: When Log Messages window is narrow, Filter box placeholder text may cover up the Filter Types button
 * Fixed issue #3090: Show Log window stuck with "Fetching changed files..."
 * Fixed issue #3084: Improve info message for merge-doc.js and drop broken URL
 * Fixed issue #3085: merge-doc.js: Word 2007 does not make a three-way comparison and the documents are shown in wrong order
 * Fixed issue #3086: merge-doc.js: Merge document in word >=2010 leaves three open windows
 * Fixed issue #3096: Duplicate 'Save as...' context menu items appear when closing and opening 'View Patch' window
 * Fixed issue #3093: Icon overlay might show ignored directories containing files as modified
 * Fixed issue #3076: Commit dialog opens with incomplete rendering in Windows 7 classic theme
 * Fixed issue #3094: Diff command results in crash
 * Fixed issue #3041: Commit Window might freeze when clicking on the last modified header shortly after opening
 * Fixed issue #3061: MenuButton popup might show directly under mouse arrow
 * Fixed issue #3108: Versioned file in ignored folder causes wrong overlays
 * Fixed issue #3109: Bad greying out of outer paths (other paths with same prefix also match)
 * Fixed issue #3132: Post commit hook doesn't show up on settings dialog
 * Fixed issue #2990: SendmailDlg: Don't auto select entries when using arrow keys
 * Fixed issue #3134: Deletion of submodule does not allow user to select the deleted (red) submodule on commit
 * Fixed issue #3138: "Check for modifications", "Revert" and other dialogs do not work after git update to version 2.16.0: "fatal: empty string is not a valid pathspec"
 * Fixed issue #3139: Git SSH operations do not work after git update to version 2.16.0 if ssh URL contains a port
 * Fixed issue #3143: Remember last selection of "Show nested refs" when browsing references
 * Fixed issue #3152: TortoiseGitMerge: Single pane view as default
 * Fixed issue #3158: TortoiseGitProc.exe hangs with 100% CPU when displaying commit window
 * Fixed issue #3153: "Failed to parse config file" if .gitconfig or .gitmodules use CRLF and contain blank lines
 * Fixed issue #3155: Can't parse config or .gitmodules files if the encoding is UTF-8 BOM

== Known issues ==
 * Due to changes in Win 10 1709 TortoiseGit(Merge) might start up slowly or gets slower over time without the patch KB4058258 (OS Build 16299.214) released on 2018-01-31; check Windows update (cf. issue #3087).
 * Due to a bug in Windows 10 1709 the mouse might jump on Drag in Commit Dialog (cf. issue #3145)

= Release 2.5.0 =
Released: 2017-07-23

== Major change ==
 * VS2017 is used for building TortoiseGit
   On x64 versions of Windows, the TortoiseGit context menu and overlays won't show for pure 32-bit applications in their file-open/save dialogs until you install the 2015 C++-runtime for x86.
   https://www.microsoft.com/en-us/download/details.aspx?id=52685 (select the vc_redist.x86.exe file for download).

== Features ==
 * Fixed issue #2931: Make “ChangeList” grids in “Git synchronization” multi-selectable
 * Update Scintilla to 3.7.5
 * Fixed issue #2949: Don't hide "Show log" button when fetch/pull was not successful
 * Fixed issue #2619: Add basic support for "git worktree"
 * Fixed issue #2966: Do not need to confirm cancel out of commit when there are no changes left
 * Fixed issue #2861: Cloning a repository with many files tracked by git-lfs is extremely slow
 * Various High DPI optimizations
 * Update libgit to 2.13.1
 * Update zlib to 1.2.11
 * Update apr and apr-util
 * Fixed issue #2988: Add `Show/hide ignore local changes flagged files` in Log Dialog
 * Fixed issue #2999: Log dialog: Copy tag to clipboard
 * Fixed issue #2964: Blame: gloss over per-line commit reference if duplicated
 * Fixed issue #2429: "Abort merge" should allow to select "git reset --merge"
 * Fixed issue #2448: TortoiseGitBlame: Line Wrapping
 * Fixed issue #2550: Search functionality on message in the RefLog window
   CTRL+F and F3 already opened a search dialog, now there also is a search button
 * Fixed issue #2599: Confusing titles when resolving a rebase or a merge conflict
 * Fixed issue #3008: Allow to push individual tags
 * Fixed issue #2973: Allow to compare local and remote tags using SyncDlg
 * Fixed issue #2775: Fetch And Rebase doesn't rebase if nothing is fetched
   It's configurable now whether opening the rebase dialog is skipped if nothing was fetched or current HEAD is up2date or newer
 * Fixed issue #3016: Add context menus to the header views in three way diff mode to open TMerge again with the diff shown in the corresponding file
 * Fixed issue #2980: Since TortoiseGit 2.4.0 the icon overlays are case sensitive. if you really want to change this default, you can disable the advanced setting "OverlaysCaseSensitive". This is, however, not the default and not recommended as some git tools such as "git log" are case sensitive on paths and might show an incomplete history.
 * FileDiffDlg: Allow to use alternative diff tool by pressing Shift
 * Allow to view diff on Delete/Modified conflicts
 * Sync smart tab detection code with TortoiseSVN
 * Ask before pushing all local branches to a remote
 * TGitBlame: Allow to search both directions
 * LogDlg and CommitDlg: Provide more copy options
 * GitStatusListCtrl: Use logical (stable) sort if enabled

== Bug Fixes ==
 * Fixed issue #2909: Commit window unclosable after clicking "No" and "do not ask again"
 * Fixed issue #2911: Doing Add on repository root fails with libgit2 returned invalid path"
 * Fixed issue #2791: Start Bisect UI incomplete
 * Update PuTTY to 0.70 (security fix, cf. https://www.chiark.greenend.org.uk/~sgtatham/putty/changes.html)
 * Fixed issue #2935: Icon overlay not shown for files on network UNC paths
 * Fix possible crash in TortoiseGitMerge when applying patch
 * Fixed issue #2942: Can't update Remote Branch of Pull dialog with Browse references dialog
 * Fixed issue #2951: Graphics corruption on taskbar overlay with UI scaling
 * Fixed issue #2945: Rebase dialog should remember the last position of the divider
 * Fixed issue #2947: Reinitializing a repository using "git init --separate-git-dir" turns all overlay icons to added
 * Allow snippets to include new lines (using "\n" notation)
 * Spell checker wrongly marked styled words as misspelled (e.g. _example_)
 * Fixed issue #2960: libgit2 fails to resolve absolute symlinks
 * Fixed issue #2963: Rebase dialog does not change "Start (FastFwd)" button during rebase process
 * Fixed issue #2968: Active urls in output windows opened when hitting ESC
 * Fixed issue #2985: TortoiseGit hangs when prematurely double clicking on "Please wait..."
 * Fixed issue #2979: gitignore patterns are always treated case sensitively for overlay icons
 * Fixed issue #2998: Resizing dialogs might lead to extension of clickable checkox area
 * Significant TGitCache rewrite which reduces disk access and fixes other issues:
   * Fixed issue #2989: TGitCache: Significantly reduce refresh requests send to Windows Explorer (causing Explorer to freeze)
   * Fixed issue #2766: TGitCache: Icon Overlay might show ignored files as non-versioned
   * Fixed issue #2818: TGitCache: overlays sometimes blink in and out of existence for several minutes at a time
   * Fixed issue #1242: TGitCache might fall into an (endless) refresh loop
   * Symlinks are not shown as modified any more
 * Missing index is not an error condition, but need to be handled like an empty index
 * Shell overlay cache: Don't show .git file with unversioned icon
 * Fixed issue #3002: Push underlined hotkey is missing in log window.
 * Fixed issue #3005: TortoiseGit does not support cloning local svn repositories
 * Fixed issue #3011: clone: --bare and --origin options are incompatible
 * Fixed issue #3013: Error message if remote Git output contains non-ASCII chars
 * Fixed issue #3014: MergeDlg: Commit dialog is opened instead of resovle dialog after resolve button pressed
 * Fixed issue #2926: Don't report an error for invalid remote symbolic references
 * Fixed issue #2955: LogDlg: infinite line to parent when initial commit is branched
 * Fixed issue #3017: Spaces at the beginning of the URL breaks pushes
 * Fixed issue #2258: Autocomplete for Remote URL box in Sync screen doesn't work
 * Fixed issue #2976: After setting the config `include.path` key, can't delete the branch which is tracking the remote branch
 * Fix possible crash if "git.exe diff-index" exits with an exit-code != 0, but no error message
 * Do not append empty pathspec to "git clean"
 * TGitBlame: Implement double buffering
 * LogDlg: Remember scroll position when refreshing working tree status
 * Fixed issue #3028: Error when using TortoiseGit cli diff command with new added file in commit
 * /startrev: and /endrev: parameters of /command:diff are no longer mixed up

= Release 2.4.0 =
Released: 2017-01-31

== Major change ==
* TGitCache and icon overlays are case sensitive now

== Features ==
 * Fixed issue #2505: Add support for bisect skip
 * Fixed issue #2757: Allow to use quotes in command line arguments, like /logmsg:"Some text ""Quoted text"" another text"
 * Fixed issue #2849: Optimize include and exclude paths for context menu and overlay icons
   We synced the include/exclude paths code with TortoiseSVN. Now you can exclude paths in an included path.
   Some people might need to update their include/exclude paths, see our manual for more information.
 * Fixed issue #2136: LogDlg: Indicate that the View and Walk Behavior buttons contain a menu
 * Fixed issue #1635: Add option to set TortoiseGitMerge foreground text colors
 * Fixed issue #2586: Integration of further hooks: pre-rebase and post-commit
 * Fixed issue #2444: Drag and drop on commit dialog to include files in the list for committing
 * Browse References Dialog: Allow to filter for merged and unmerged branches
 * Fixed issue #2273: Remember the width of the "view patch" window
 * Fixed issue #2710: Allow start-commit hook to prevent the Commit dialog from showing
 * Fixed issue #2865: Clickable URLs in TortoiseGit output window
 * Fixed issue #2154: Copy to clipboard function in show log window doesn't include annotated tag or notes messages
 * Fixed issue #1668: Allow submodules to be removed ("Delete" is now available for submodules)
 * Update libgit2 to 0.25.1
 * The shipped libgit2 uses the CrLf filter logic from Git >= 2.9
 * Fixed issue #2863: Increase text box size limit for command progress dialog and make it configurable
 * Fixed issue #2274 and issue #2750: Add advanced option for controlling which date/time is used for squashed commits (setting: SquashDate)
   1: Use date of last commit, 2: Use current date, 0: Use time of first commit into which others are squashed (default)
 * Fixed issue #2633: Check for Modifications dialog doesn't refresh after commit
 * Fixed issue #1656: Add "dcommit" to change sets in "log messages"
 * Fixed issue #2741: TortoiseGitBlame: Allow to limit blame on first parents
 * Fixed issue #2826: Highlight commit to which the parent repo points to in the log for submodules (named: super-project-pointer)
 * Added a first start wizard which can be re-run from TortoiseGit settings
 * Fixed issue #2593: Hitting escape closes the commit window without any attention message
 * Fixed issue #2702: File selection dialog should not open for Add if only files are selected
 * Fixed issue #1749: Create Patch Serial: Remember "Since" branch
 * Fixed issue #2264: Insert new items into interactive rebase and cherry-pick process
 * Fixed issue #2456: Allow to compare change sets in log
 * Updated libgit to 2.11
 * Updated pcre to 8.40
 * Several high DPI optimizations
 * Fixed issue #2889: TortoiseGitMerge: Show inline diffs in one-pane-view mode as well, at least for single line changes
 * Fixed issue #2894: Enable/disable check boxes for hook scripts
 * Enable/disable check boxes for bugtraq plugins
 * Fixed issue #2283: Improve symbols for "Symbolize ref names"
 * Fixed issue #2746: SubWCRev equivalent required: GitWCRev added
 * Fixed issue #2082: RebaseDlg: Reorder commits via drag'n'drop
 * Fixed issue #2210: Do not allow merging from the current branch to the current branch

== Bug Fixes ==
 * Fixed issue #2837: Fixed layout issues on settings dialog
 * Fixed issue #2839: The dialog "check for updates" has a resize issue
 * Fixed issue #2845: Sticky button when resizing the "Rename dialog"
 * Fixed issue #2846: Spell checker won't add unknown words to dictionary. The dictionaries are now saved as UTF-8.
   If you have non ascii chars in your dictionary and want to keep those, you need to manually convert these to UTF-8.
   The dictionaries can be found in %APPDATA%\TortoiseGit\*.dic.
 * Fixed issue #2850: The installer does not completely support high-contrast-mode
 * Fixed issue #2853: Commit message autocompletion failed sometimes for words with different casing
 * Fixed issue #2851: Switching high-contrast-mode on or off, does not cause change of used UI colors
 * Fixed issue #2829: Remembering the last selected line might not work when a conflict was manually resolved
 * Fixed issue #2868: Show changes as unified diff might fail (using Cygwin git)
 * /command:showcompare /unified did not honor path filters correctly
 * Fixed issue #2870: Save unified diff can cause TortoiseGit to not respond
 * Fixed issue #2217: LogDlg: Refresh working tree status and file list after changes to working tree
 * Fixed issue #2833: Pull with 'pull.rebase=preserve' does rebase on invalid upstream
 * Fixed issue #2859: Cannot clone URLs which contain non-ASCII chars with Git for Windows 2.10.1 and 2.10.2
 * Fixed issue #2872: Rebase local/remote reversed for tree conflicts (delete/modify conflicts)
 * Fixed issue #2491: Optimize way for creating temporary files in order to improve compatibility with certain backup softwares
 * Fixed issue #2875: Fixed error in settings hint text
 * Fixed issue #2878: SplitContainer redraw issues in Cherry Pick dialog
 * Fixed issue #2877: Git fetch all with rebase might produce error
 * Fixed issue #2874: Horizontal scroll reversed in TortoiseGitMerge
 * When showing an autocompletion list, don't bail out if one is already shown but just update it
 * Fixed issue #2887: ListView flickering in Browse References dialog
 * Fixed issue #2891: "Show log" on a repo with 200k files is extremely slow due to each file attributes being queried individually
   This also improves submodule support as we rely on the directory/file information we got from git now.
 * Fixed issue #2896: Blame revisions ListView selection and flickering issues
 * Fixed issue #2883: Improve wording for our "needs merge" hint in commit dialog
 * Fixed issue #2898: Branch name forced to be lower what leads to pull error
 * TGitCache: Do not accidentally report up status of submodules to parent repo if not enabled
 * TGitCache: Prevent more FILE_SHARE_VIOLATIONS for deleting files
 * Fixed issue #497: TGitCache.exe won't let user delete folder
 * Fixed issue #2899: Fall back to %USERPROFILE% if %HOMEDRIVE%%HOMEPATH% is not a directory for %HOME% detection as Git for Windows does
 * Fixed issue #2664: Windows explorer slow/very long delays with shell extension enabled

= Release 2.3.0 =
Released: 2016-10-01

== Features ==
 * Fixed issue #2755: TortoiseGitMerge: find dialog box does not remember desktop location between invocations
 * When an alternative/external diff or merge tool is configured, you can now press the shift key while opening the diff to fall back to TortoiseGitMerge
 * Fixed issue #2812: Better indicate conflicts on stash pop and allow to automatically show changes
 * Fixed issue #2439: Add 'show branches this revision is on' to the blame window
 * Fixed issue #2026: Allow to navigate to branch shown on "Show branches this commit is on" dialog
 * Fixed issue #2806: Allow to turn off tooltips in file lists (in advanced settings using ShowListFullPathTooltip)
 * Fixed issue #2475: Allow to use mailmap translations in log dialog
 * Fixed issue #2816: Add mnemonics to Reset, Switch, Merge Abort and Export dialogs
 * Fixed issue #491: Rename dialog should have a browse button
 * TortoiseGit now uses latest libgit2 which supports git index version 4
 * Added support for GIT_ASK_YESNO wrapper
 * Updated libgit to 2.10.0
 * Fixed issue #2830: Log from Repository Browser should use selected branch by default
 * Fixed issue #2829: Add, Commit, Rebase, Repository Status, Resolve, and Revert dialogs try to remember the last selected line on refresh (e.g., after resolving a conflict)
 * Rebase and Commit Dialog: When clicking on OK or resolve and a conflicted file is detected, jump to it (aka goto next conflict)

== Bug Fixes ==
 * Fixed issue #2789: Sync Dialog In ChangeList tab auto-resize column not optimal
 * Fixed issue #2792: Mouse pointer disappears for the log window's context menu under Windows 8.1 and Windows 10
 * Fixed issue #2800: Authentication with non-ascii password fails
 * Fixed issue #2798: Commit message autocompletion doesn't work with UTF-8 encoded files
 * Fixed issue #2797: RebaseDlg: Make branch selectors adjust with resized dialog
 * Autocompletion of filenames with umlauts in the commit dialog did not work
 * Fixed issue #2799: Column sizes in "Browse references" dialog are not remembered
 * Try harder to not report unchanged files as changed (if modification time changed)
 * Fixed issue #2809: TortoiseGitMerge: Block Control Button is always disabled on conflict resolution
 * Fixed issue #2814: "Git Check for modifications" and Commit dialog runs batch files for unversioned or ignored files
 * Fixed issue #2815: TortoiseGitMerge might hang with ignore comments enabled
 * Fixed issue #2557: TortoiseGit Update closes windows explorer but might not reopen it

= Release 2.2.0 =
Released: 2016-07-02

== Features ==
 * Updated libgit to 2.8.3
 * Fixed issue #2773: Directory renames should be displayed shorter
 * GitStatusList now automatically adjusts the width of columns. This can be disabled by manually sizing it.
 * Fixed issue #2705: TGIT should allow cloning and/or creating from within a non-empty repository
 * Update Scintilla to 3.6.6
 * Fixed issue #2271: "Check For Updates" dialog should be resizable
 * Fixed issue #1953: Add drag handler to Repository Browser
 * Fixed issue #2770: Include complete relative path in TortoiseGitMerge

== Bug Fixes ==
 * Fixed issue #2745: TortoiseGit 2.1 crashes on broken git config
 * Fixed issue #2759: Swapped THEIRS and MINE in cherry-pick conflict dialogs and context menus
 * Fixed issue #2767: The online help of Settings->Git->Remote should explain the "Push Default" checkbox
 * Fixed issue #2772: Comparing with added file might result in comparison with empty file
 * Fixed issue #2774: Pull dialog with Russian LangPack has three defficiencies
 * Fixed issue #2783: "Delete and add to ignore list" does not work when more than 16 files are selected
 * Fixed issue #2740: Order of compared references in revision graph is labelled inverted
 * Fixed issue #2785: Rebase/Cherry-pick with conflict in renamed file fails
 * Fixed issue #2714: TortoiseGitMerge should redraw if font is changed
 * Fixed issue #2756: TortoiseGitMerge: Regex Filter doesn't filter from "Previous diff", "Next diff" operation
 * Fixed issue #2736: stash list/pop missing when refs are packed
 * /revision1: and /revision2: parameters of /command:showcompare are no longer mixed up

= Release 2.1.0 =
Released: 2016-03-26

== Changes ==
 * We disabled the stripping of comments on commit messages by default again (see issue #2715)

== Features ==
 * Update PuTTY to 0.67
 * Fixed issue #2733: Hide commit button after file add when invoked from commit dialog
 * Fixed issue #2734: When pull.rebase is set, start rebase just after fetch, not after OK button
 * Fixed issue #2731: Improved autolist.txt regex for C# files
 * Update libgit2 to 0.24.0
 * Update Scintilla to 3.6.4

== Bug Fixes ==
 * Fixed issue #2719: Commit & Push in CommitDlg doesn't respect default remote and pushbranch settings
 * Fixed issue #1902: CommitDlg: Do not lose SQUASH_MSG contents
 * Fixed issue #2732: Commit dialog: Message field should have focus (when patch is shown)
 * Fixed issue #2730: Pull with rebase with preserve merges not working for noops
 * Fixed issue #2728: Cherry Pick is not working in case of conflict and empty message
 * Fixed issue #2715: Cannot commit with a commit message starting with a hash (#) character
 * Updated libgit to 2.5.5 which includes fixes for CVE-2016-2315 and CVE-2016-2324
 * Fix the the credential helper settings dialog

= Release 2.0.0 =
Released: 2016-02-29

== Changes ==
 * Custom dictionaries are no longer loaded when located in %PROGRAMFILES%\TortoiseGit or %PROGRAMFILES%\TortoiseGit\bin-directory
   Must be in  %APPDATA%\TortoiseGit\dic or %PROGRAMFILES%\TortoiseGit\Languages folder (former has priority)
 * Dropped TGitCacheCheckContent configuration setting, please use TGitCacheCheckContentMaxSize instead (settings will be automatically migrated)
 * Pre- and post-push hooks do not get the path as first parameter any more
 * Git for Windows 1.9.5 or newer is now required
 * TortoiseGit now applies the same whitespace and new line sanitizing rules as git core for commit messages by default
 * TortoiseGit now strips commented lines (starting with #) on commit messages by default
 * We changed the version schema to X.Y.Z, where X is incremented for major changes, Y for every stable release, and Z!=0 represents preview releases

== Features ==
 * Fixed issue #2641: Commit: Pre-select first item from "Changes made" list
 * Allow to reset stored decisions (cf. issue #2640)
 * Fixed issue #2643: Set branch description on its creation
 * Fixed issue #1629: Have the push dialog opened via right-click in log default to branch that was actually clicked on
 * Update TortoiseGitPlink to version 0.66
 * Fixed issue #943: Allow to use keyboard shortcuts in Git progress dialog (e.g., ALT+R for ReCommit after commit)
 * Fixed issue #2314: Allow to preserve merges on rebase
 * Fixed issue #2673: Display tracked remote URL in folder properties
 * Fixed issue #2630: TGitBlame: Allow to blame files of different working trees w/o restarting
 * Fixed issue #2679: Unnecessary horizontal scrollbar is shown in case logwidthmarker is set
 * Rebase dialog now honors rebase.autostash=true
 * Fixed issue #2270: Print a warning on a merge commit, so that changes are not unchecked unintentionally
 * Fixed issue #2310: Add support for notes.rewrite.rebase
 * Fixed issue #2629: "Browse References Dialog" save sort column + order
 * Fixed issue #2678: Filter out special ref names in log graph
 * Fixed issue #2692: Add support for pull.rebase and branch.name.rebase
 * Fixed issue #2701: Add and Revert should respect Autoclose settings and not show any dialog boxes
   Maybe we introduce finer grained auto close levels later.
 * Fixed issue #1899: Support cherry-picking merge revisions
 * Fixed issue #2551: Allow to create patches w/o a/ and b/ prefixes
 * Fixed issue #2302: One button to do Commit & push
 * Fixed issue #527: Fix the dialog after commit for us to be able to continue committing
 * Fixed issue #2697: Display "In Commits" and "In ChangeList" tabs for Fetch&Rebase in Sync dialog
 * Fixed issue #2484: Recursive option is not remembered in clone dialog
 * Fixed issue #2259: SyncDlg: Allow to fetch all remote references of a specific remote instead of a single branch (Fetch all refs)
 * Fixed issue #1130: Sync dialog forgets the remote branch every time (ask whether to store a tracked branch)

== Bug Fixes ==
 * Fixed issue #2647: TortoiseGitBlame does not display files correctly with mixed line endings (such as CRCRLF)
 * Fixed issue #2650: Empty ListViews drawing issue
 * Fixed issue #2662: Border line in commit text boxes is shown 2 characters past the specified width
 * Fixed issue #2660: No colors in git.exe progress dialog since 1.8.16
 * Fixed issue #2646: Library broken in Windows 10
 * Fixed issue #2670: LogDlg: cannot paste to "Filter paths"
 * Fixed issue #2676: Swapped Theirs and Mine in Edit conflicts outside of rebase dialog on rebasing
 * Fixed issue #2690: Failed to Show log from repository browser when that repository is located on a drive
 * Fixed issue #2655: Resolve does not work on multiple selection during deleted-modifed conflict resolution
 * Fixed issue #2668: TortoiseGit commit with git-lfs files, show me a error: ".git/index.lock" file exist
 * Fixed issue #2638: TGitCache crashes on a broken repo (out of bounds read in libgit2)

= Release 1.8.16.0 =
Released: 2015-11-01

== Features ==
 * Updated libgit to version 2.5.0
 * Fixed issue #2563: No Windows 10-specific library icon
 * Fixed issue #2568: Add Fast Forward Only option to the merge dialog (--ff-only)
 * Fixed issue #2579: Add option to retry push after failed push followed by rebase
 * Fixed issue #2583: No overlay icon theme for Windows 10
 * Fixed issue #2578: Resolve Dialog <enter> should open "Edit conflicts"
 * Fixed issue #2590: Allow to resolve conflicts with TortoiseGitIDiff by clicking on select
 * Added branch revision number for tracking of the source code version of a branch in automated builds using "git rev-list --count --first-parent"
 * Allow to choose Git Credential Manager for Windows (GCM)
 * Fixed issue #2604: Tag using TortoiseGitProc.exe /command:tag should accept a tag name argument
 * Fixed issue #2609: Start scrolling the log from the bottom of the window rather than the top when finishing the progress
 * Fixed issue #2608: Need a cancel option when cancelling a "restore after commit"
 * Fixed issue #2531: Can't filter message in annotated tag or text in notes
 * LogDlg: Clear filter on escape (if set) or exit dialog
 * TortoiseGitMerge: Allow to change file encoding
 * TortoiseGitMerge: Move all commands to the first view to avoid having to switch views
 * Add find bar to patch viewer
 * Added some new OverlayIcon styles (especially for Windows 10)
 * Update PuTTY binaries to 0.65
 * Update TortoiseOverlays to 1.1.4-26626

== Bug Fixes ==
 * TortoiseGitMerge highlights wrong line in case of file starts with LF+CRLF
 * Fixed issue #2337: CommitDlg: recent commit messages list isn't updated after commit in other dialog windows
 * Fixed issue #2377: BrowseRefsDlg: Don't enter branch directory when renaming a branch
 * Fixed issue #2559: Paths may change to lowercase in explorer
 * Fixed issue #2492: ssh key not used for new remote after clone
 * Fixed issue #2582: Taskbar icon color differs when drive letter is uppercase/lowercase
 * Fixed issue #2580: Clone dialog: Dir/Web button is confusing
 * Fixed issue #2558: Can't create a new temp file/folder after upgrading to Win10
 * Fixed issue #2581: Blame is slow on big files
 * Fixed issue #2567: Log performance slow on huge repository
 * Fixed issue #2585: Language pack files aren't deleted after removing TortoiseGit
 * Fixed issue #2553: Git cleanup fails for renamed submodules
 * Fixed issue #2598: Git Daemon error with root path (as "D:\")
 * Fixed issue #2615: Error during Rebase Edit/Split on a root path
 * Fixed issue #2528: Unreadably long message box when failing to read a file in a new project
 * TGitCache: Fix possible deadlock and performance optimizations
 * Fixed issue #2560: Problems with MS Outlook and "Name" <john@example.com> formatted email-addresses
 * Fixed issue #2624: Encoding issues when using suggested words from spell checker
 * Fixed issue #2602: templatedir not respected if directory starts with dot
 * Fixed issue #2622: TortoiseGit shows context menu for two unversioned files even if told not to do so

= Release 1.8.15.0 =
Released: 2015-08-02

== Features ==
 * Fixed issue #2245: Make the meaning of "Squash" clearer
 * Fixed issue #2488: BrowseRefsDlg: Option to hide nested branches
 * Fixed issue #2490: BrowseRefsDlg: Allow to configure tracked branches
 * Fixed issue #2469: Support reviewing merge commits (git show merge-commit)
 * Add full support for Git for Windows 2.x and windows-wide system config
   (https://git-for-windows.github.io)
 * Fixed issue #2232: Change Show Log to display all lines of multiline commit comments in the message column
 * Fixed issue #1930: Navigate directly to a commit in "Show log" by pasting its hash
 * Fixed issue #2280: Ability to use Msys2 git instead of Git for Windows
   Check out the manual (keyword "Msys2 git") regarding Msys2 Git support and configuration hints.
   Please note that Msys2 Git is not officially supported by TortoiseGit as the developers only use Git for Windows. Bug reports, however, are welcome.
 * Fixed issue #1003: Show Log does not remember the from-date (configurable now)
 * Fixed issue #1793: Fetch&Rebase: Launch rebase only if the branch isn't up to date
 * Fixed issue #1886: Fetch&Rebase should allow automatic branch update if FF
 * Fixed issue #836: CommitDlg: Do not auto-select files which are deleted in file system, but are not deleted in the index on commit dialog (optional)
 * Fixed issue #2513: TortoiseGitUDiff: Add keyboard shortcuts

== Bug Fixes ==
 * Fixed issue #2495: "Show Reflog" dialog shows empty action for "push" entries
 * Fixed issue #2500: Amend with date reset causes an error with git 2.x
 * Fixed issue #2507: Support keyboard shortcuts in yes/no prompts
 * Fixed issue #2496: LogDlg: Controls may overlap on screen resolution change
 * Fixed issue #2153: Log window resize should expand commit list
 * Fixed issue #2509: Prompt for stash before rebase is not matched with pop stash  after rebase
 * Fixed issue #2510: Non-correctly visualized settings dialog on modern high-DPI displays
 * Fixed issue #2514: diff uses wrong tool in case the filename matches an extension for which a special diff tool is registerd
 * Fixed issue #2487: Show log dialog lose focus of "working dir changes" after content refresh
 * Fixed issue #2517: Submodule Update dialog cannot be re-sized
 * Fixed issue #2504: Problems with MS Outlook and generated emails
 * Optimized TortoiseGitBlame to be used with high contrast themes and black background colors
 * Fixed issue #2529: The status of files which are not checked should be the same in the index after commit
   Unchecked deleted/renamed files were not put into previous state in index after commit
 * Fixed issue #2537: TortoiseGitPlink will not connect to OpenSSH 6.9
   Upgraded TortoiseGitPlink to version 0.65
 * Shell(Extended): Fix mismatch of directory and file status; Only staged changes Were considered for the calculation of the overlay icons of directories.
 * Fixed issue #2546: Location bar in TortoiseGitMerge missing
 * Fixed issue #2545: Incorrect TortiseGitMerge behavior when ignore comments is on
 * Fixed issue #2544: LogDlg giving inconsistent results with rename and merge files with follow renames
 * Fixed issue #2479: TortoiseGit does not work in hard link folder

= Release 1.8.14.0 =
Released: 2015-04-08

== Features ==
 * Fixed issue #2441: A way to disable the sound that is played on errors
 * Updated shipped TortoiseGitPlink and putty binaries to version 0.64
 * Fixed issue #2466: TortoiseGitUDiff tool cannot be localized
 * TGitCache: Improve reaction time for propagating changes to explorer
 * Fixed issue #2031: Missing option to disable displaying "FETCH_HEAD" in "Switch/Checkout" dialog box
 * Log, RepoBrowser, and Rebase Dialogs: Allow to compare arbitrary files across commits
 * Fixed issue #2534: Use the current time for amending commit (also sets commit time)
 * TortoiseGitBlame: Implemented search forward (F3) and search backward (Shift+F3)
 * Allow to compare file with deleted file in CommitDlg (e.g., useful for renames)
 * Allow to use Explorer context menu options from TortoiseGit context menu
 * Sort remotes logically/case-insensitively

== Bug Fixes ==
 * Fixed issue #2427: "Submodule of Project: " cannot be localized
 * Fixed issue #2432: MessageBox buttons cannot be localized
 * Fixed issue #2433: Cannot see the log in Diff with previous version
 * Fixed issue #2453: The overlay icon of committed files in a submodule named with Chinese characters is unversioned icon
 * Fixed issue #2455: "Diff with ..." menu cannot be localized
 * Fixed issue #2431: Add fails in submodule after upgrade from 1.8.12 to 1.8.13
 * Fixed issue #2449: wrong column info in tag reference dialog
 * Fixed issue #2436: Overlay icons gradually disappear or show files as unversioned after a short time
 * Fixed issue #2374: Rebase option in config not working anymore for pull
 * Fixed issue #1440: Different status of modified renamed or moved files in Show log dialog, Check for Modifications dialog and Commit dialog
 * Fixed issue #1501: Unchanged files appears modified in Show Log dialog
 * Fixed issue #2477: Change "Split commit" label to "Edit/Split commit" in Rebase dlg
 * Fixed issue #2481: "Start registry editor" does not work properly in non-English locales
 * Fixed issue #2480: CommitDlg: auto-complete doesn't include removed items
 * Fixed issue #2451: Cleanup fails quietly if file is in use
 * Various bug fixes based on our newly added unit tests
 * Not all remotes showing in Push/Pull/Fetch/Sync dialogs (was limited to 25)

= Release 1.8.13.0 =
Released: 2015-02-15

== Features ==
 * Improved auto update
   Version checks will use SSL (on Vista or newer systems)
   New version.txt file format with more options
 * Fixed issue #2243: Submodule red-icon doesn't propagate to higher folders (configurable now)
 * Improved overlay icon accuracy
   You might need to kill TGitCache.exe once using the TaskManager in order to reset its cache
 * Fixed issue #2388: See the exact time when the Relative time in log enabled
 * Fixed issue #2346: Add drag'n'drop to "Apply patches" window
 * Fixed issue #2357: Save the state of Search criteria checkboxes in Log dialog
 * Fixed issue #2420: Make push available in log for arbitrary commits (when pressing the shift key)
 * Fixed issue #2351: Allow upstream to be separate from onto in rebase
 * Fixed issue #1400: Allow the use of tags within the Git Rebase dialog
 * Fixes issue #2417: Resolving a conflict forces refresh of Commit Dialog
   A new advanced option (RefreshFileListAfterResolvingConflict) was added which controls
   whether file lists are refreshed after resolving conflicts. By default this is set to
   true, but can be disabled in cases where refreshing the list takes lots of time or
   people don't want the list to automatically scroll to the top (this also mitigates
   issue #1949 until we have a cleaner fix). F5 for manual refresh is needed if enabled.
 * Fixed issue #56: Ability to use Cygwin's git instead of msysGit
   Check out the manual (keyword "Cygwin git") regarding Cygwin Git support and configuration hints.
   Please note that Cygwin Git is not officially supported by TortoiseGit as the developers only
   use Git for Windows. Bug reports, however, are welcome.

== Bug Fixes ==
 * Fixed issue #2359: Selected files counter not updated after revert
 * Fixed issue #2362: git.exe get stuck on Win XP
 * Fixed issue #2372: Remote Config Tags Dropdown doesn't enable Apply-Button when switching to Reachable
 * Updated libgit2 in order to fix CVE-2014-9390.
   TortoiseGit is not affected in its default configuration (libgit2 has to be manually enabled for cloning).
   Git for Windows and mSysGit < 1.9.5 are affected, so an update highly recommended.
 * Fixed issue #2385: 'Mail' - 'Use configured server' & 'none'... seems cannot be localized
 * Fixed issue #2356: Rebase dialog should also auto-link to issue tracker
 * Fixed issue #2390: /command:log /outfile not written
 * Fixed issue #2391: Cannot clear "Load Putty Key" in clone dialog persistently
 * Fixed issue #1789: Tooltips not properly displayed in Log List if that commit has refs
 * Fixed issue #2353: Link to bug tracker not available in Show Log dialog on Win8+
 * Fixed issue #2368: CTRL+ENTER locks up GUI on Updating Index...
 * Fixed issue #2414: SendMail doesn't correctly place the mail in to list
 * Fixed several issues in libgit2 regarding SafeCrLf and AutoCrlf

= Release 1.8.12.0 =
Released: 2014-11-25

== Features ==
 * Fixed issue #2272: Export Dialog auto select tag if the revision has tag
 * We now use a 4096-bit RSA key with SHA2-512 for signing and verifying our releases instead of a 1024-bit DSA key with SHA1
   The new key is signed by the old key. You can get the fingerprint from a trusted TortoiseGit installation by issuing
   "TortoiseGitProc.exe /command:pgpfp"
 * Fixed issue #1928: Hotkeys in "Show log" dialog for navigating back / forward
 * Fixed issue #1316: Add git describe
 * Fixed issue #2294: Submodule Update dialog doesn't save its state
 * Fixed issue #2176: Color config for "View Patch" Window & Tortoise(Git)UDiff
 * Fixed issue #2331: Show prefix log asterisk in Log Dialog
 * Fixed issue #2157: TortoiseGitMerge does not delete temporary files on close (marking as "resolved" in TGit was necessary)
 * Fixed issue #1950: Log Dialog: File list filter
 * Fixed issue #2330: Optimize submodule conflict resolution
 * Fixed issue #2332: TortoiseGitMerge: Move "Create patch file" to the File menu
 * TortoiseGitMerge: Updated EditorConfig version to 0.12
 * Fixed issue #2341: Jump to search box when pressing CTRL+E
 * Custom dictionaries for the spell checker can now be put into the %APPDATA%\TortoiseGit\dic folder (w/o administrator privileges).
   All other locations within the TortoiseGit installation folder (e.g. bin, dic, ...) except Languages are now deprecated.
   See the manual for more information.
 * TGitCache: Overlay update improvements and speedups

== Bug Fixes ==
 * Fixed issue #2260: Clicking in blank space in Commit dialog causes all unversioned files to become selected
 * Fixed issue #2290: "Pulled Log" broken
 * Fixed issue #2281: TGit 1.8.11 is not using %HOME% correctly
 * Fixed issue #2306: TortoiseGitMerge ToolTip messages for Previous/next inline difference mixed up
 * Fixed issue #2308: Pressing ESC in the skip-worktree confirmation dialog box selects 'yes'
 * Fixed issue #2309: [Show log of aaaa..bbbb] on sub directory shows logs on root directory
 * Fixed issue #2126: Rebase: Squash after conflict causes additional commit
 * Fixed issue #2313: [Clean to recycle bin] after Clean-up dry run removes unexpected files
 * Fixed issue #874: Add --rebase option to pull dialog
 * Fixed issue #2316: Error on comparing files when git config core.autocrlf ends with 2+ spaces and then a comment
 * Fixed issue #2323: TortoiseGit does not pull --tags despite checking Tags
 * Fixed issue #2327: Help button is broken in "SVN Commit Type" dialog
 * TGitCache now checks file sizes before checking file contents. This should mitigate possible "file is locked" problems.
 * Fixed issue #2329: Changes track remote branch when fast forward is used
 * Fixed issue #1872: Rebase edit doesn't amend files but only the commit message
 * Fixed issue #2342: Ignore whitespace blame option not work
 * Fixed issue #2311: Empty commits cannot be rebased
 * Fixed issue #2312: Fix UTF-8 AutoCRLF issues with libgit2
 * Fixed issue #2345: The Show Log dialog's View Patch side window is empty when the Working dir changes line is selected and no file is selected
 * Fixed issue #2348: Conflicts during rebase appends "conflicts" to commit message

= Release 1.8.11.0 =
Released: 2014-08-22

== Bug Fixes ==
 * Fixed issue #2257: Fetching & pushing using ssh.exe not working with TortoiseGit 1.8.10
 * Fixed crashes while opening the revision graph in the x64 version on some AMD CPUs
 * Fixed some other possible crashes when working with broken repositories or writing files failed
 * TortoiseGitMerge did not show ribbon bar with Portuguese (Brazil) language pack loaded

= Release 1.8.10.0 =
Released: 2014-08-12

== Features ==
 * Updated shipped libgit2 to version 0.21
 * Fixed issue #1605: Add TortoiseGit start and pre commit hooks
 * Fixed issue #2170: Please add interface to "git svn log -v"
 * Fixed issue #1787: auto-complete label when writing commit message
 * Fixed issue #2241: Cleanup: result window of dry run should offer to "really remove"
 * Fixed issue #1596: Added basic support for clean/smudge filters
 * Fixed issue #2167: Support git push --force-with-lease option
 * TortoiseGitMerge: Support EditorConfig indent_style(space/tab) and indent_size
 * TortoiseGitMerge: Can specify number of context lines or follow diff.context in a patch file
 * Can sort tags in reversed order
 * Can shallow pull/fetch a shallow clone repository
 * Revision Graph: Add filter to walk from Only Local Branches

== Bug Fixes ==
 * Fixed issue #2216: Add fails with message: libgit2: "failed to parse 'warn' as boolean"
 * Fixed issue #2218: Tortoise Git Extra Backslash with SUBST Drive Paths
 * Fixed issue #1951: Slow switch/checkout dialog
 * Fixed issue #2064: Broken characters when dragging the horizontal bar in TortoiseGitMerge
 * Fixed issue #2143: PowerShell not working in git hooks
 * Fixed issue #2222: 'Prune' in the pull dialog does not work
 * Fixed issue #2223: Move & revert operations not as expected if working tree root is directly on a drive
 * Fixed issue #2225: include.path does not understand tilde (~)
 * Fixed issue #2228: TortoiseGitUDiff incorrect font by non-ascii char name
 * Fixed issue #2230: First click on order dialog is ignored
 * Fixed issue #2003: TortoiseMerge uses wrong EOL with patches
 * Fixed issue #2234: Config file mess up if not end with LF
 * Fixed issue #2238: TortoiseGitMerge Default button in "Find" dialog does replace all
 * Fixed issue #2250: bugtraq.logregex Test incorrectly saves the order of the fields
 * TGitCache now does not check the contents of files with filesize > 10 MiB any more
   and falls back to checking the timestamp of the files (as if TGitCacheCheckContent
   is set to "false") according the the git index. This limit can be changed by adjusting
   TGitCacheCheckContentMaxSize (measured in KiB) in TortoiseGit advanced settings.
   The reason for this change is that libgit2 reads a file to memory for hashing and,
   thus, locking the file and the repository for this time span.
   Fixed issue #2240: TGitCache keeps crashing when I look at my folders or commit
 * Fixed issue #2219: "add cherry picked from" is not applied when squashing/editing the commits
 * TortoiseGitMerge: Fix some crashes when Wrap Long Lines is enabled
 * TortoiseGitMerge: Use the screen chars of the current view for the scrollbar page value
 * TortoiseGitMerge: Do not draw EOL mark in line number region
 * TortoiseGitMerge: No need to expand tab to spaces when finding inline diff positions
 * Repository Browser said commit not found in submodule

== Known Issues ==
 * There seems to be a bug in the MFC library which occurs when opening the revision graph in the x64
   version on AMD CPUs, we cannot fix this. Please vote for this on Microsoft Connect:
   https://connect.microsoft.com/VisualStudio/feedback/details/893171/c000001d-illegal-instruction-on-msvcr120-log-0x2d3-on-x64.

= Release 1.8.9.0 =
Released: 2014-06-09

== Features ==
 * Fixed issue #2152: Log window show whole commit in "View patch"
 * Fixed issue #2149: Can't search message in annotated tag or text in notes
 * Fixed issue #2172: Support num parameters of git blame -M and git blame -C
 * Fixed issue #2179: Revision comparisons against HEAD should not generate temporary files (allow to compare to working tree)
 * Fixed issue #2168: Add to the "Clean up" dialog "Recursive" option for submodules
 * Fixed issue #2196: Log dialog file list group headers show parent SHA-1
 * Fixed issue #2144: TortoiseGit should support configuring pushurl for remotes
 * Fixed issue #2155: Make "Delete Remote Tags..." more discoverable
 * Fixed issue #2164: allow Commit from Log > Working dir changes of selected files
 * Fixed issue #2096: Allow to disable blue text-label about git.exe execution timings on progress dialog
 * Fixed issue #968: Rebase / Cherry Pick dialogs should update "conflict" status when conflicts are resolved
 * Fixed issue #1706: Show log in different branch reverts to active branch
 * Fixed issue #1973: Support INS/OVR mode in TortoiseMerge
 * Fixed issue #1970: Provide replacement function in TortoiseGitMerge
 * Use libgit2 for more operations instead of calling git.exe

== Bug Fixes ==
 * Fixed issue #2158: TortoiseGit sometimes crashes when doing Sync > Pull
 * Fixed issue #2159: URL combo box in Submodule Add is not case sensitive
 * Fixed issue #2171: blame setting 'detect moved or copied line' does not work for the case 'from modified files'
 * Fixed issue #2174: Submodule update shows wrong submodule list
 * Fixed issue #2175: TortoiseGitBlame fails to search if line has non-ascii chars and system locale is not US
 * Fixed issue #2141: libgit2 still added the file with mixing EOL, while autocrlf and safecrlf are true
 * Fixed issue #2183: Explorer Property Page "Last modified" stays empty
 * Fixed issue #2180: When opening revision graph, scroll to current branch
 * Fixed issue #2104: Opening log for non-git folder results in multiple error messages
 * Fixed issue #2192: Shell context menu not detecting submodule if submodule name differs from submodule path
 * Fixed issue #2187: Misshowed branch on many dialogs in the new version
 * Fixed issue #2191: Skip-worktree or assume-valid flagged files are not always listed if subfolder is selected
 * Fixed issue #2199: Fetch dialog does not delete remote in remote list after managing remotes
 * Fixed issue #2200: Add remote name starts with # should not fetch all
 * Fixed issue #2190: "Force Rebase" after "Squash ALL" does not mark commits for squashing
 * Fixed issue #2073: Remove Entry of remote in "Remote Url" box in sync window
 * Fixed issue #2207: "Do you want to stash pop now?" dialog shows "Stash" labeled button instead of "Pop"
 * Fixed issue #2161: Windows explorer slow/very long delays with shell extension enabled and accessing network folders
 * Fixed issue #2198: MSVCR110.dll error with TortoisePlink. However, using TortoiseGitPlink is recommended

= Release 1.8.8.0 =
Released: 2014-04-01

== Features ==
 * Fixed issue #2065: Add link to fetch to screen when push failed
 * Fixed issue #1855: Support negative log filter syntax
 * Fixed issue #1029: Add function to control the TGitCache module
 * Fixed issue #2086: Rebase autoskip patches that are already in upstream
 * Fixed issue #2112: Disable option for Drag & Drop Handler
 * Fixed issue #2114: Allow to swap rebase refs
 * Updated libgit to version 1.9.0
 * Fixed issue #1920: Diff in log dialog like in commit dialog
 * Fixed issue #2134: Easier to select lines to partial commit in TortoiseGitMerge
 * Fixed issue #2135: Add menu button to open Explorer when clone finishes

== Bug Fixes ==
 * Fixed issue #2067: Normalize email with capital letters when calculating gravatar hash
 * Fixed issue #2071: TGitCache blocks Windows to eject USB drive
 * Fixed issue #2074: Time field not large enough
 * Fixed issue #1648: Issue with handles being kept when there are uncommitted changes
 * Fixed issue #2083: TortoiseGitBlame 'show unified diff' actually performs compare
 * Fixed issue #2087: Rebase ComboBox DropDown List too short
 * Fixed issue #2088: log entries have space in front of message without labels if right side drawing is enabled
 * Fixed issue #2075: Commit do not show merged files after merge
 * Fixed issue #2097: Wrong context menu when selecting ignored file in Status dialog
 * Fixed issue #2099: Cannot cancel "Delete and add to ignore list"
 * Fixed issue #2109: Checkout Tag without creating Branch - Remove Pull Option
 * Fixed issue #2106: "All local branches" option is not remembered
 * Fixed issue #2076: Issue Tracker Integration is broken in 1.8.7.0
 * Fixed issue #2124: Rebase icon not properly displayed
 * Fixed issue #2113: JiraSvn bugtraq provider's commit behavior is broken
 * Fixed issue #2128: tagopt not saved when asked to disable tag fetching
 * Fixed issue #2127: After delete last tag in Browse references, tree of refs disappeared
 * Fixed issue #2131: Commit message not used when merging with "squash" option
 * Fixed issue #2147: Resolve not dealing correctly with (modify/delete) conflicts
 * Fixed issue #2148: Cherry pick with conflicts does not add "Cherry picked from..."
 * Fixed issue #2150: Integrate with issue tracker - bug Id cannot be larger than 6 digit number

= Release 1.8.7.0 =
Released: 2014-01-12

== Features ==
 * Fixed issue #1943: Add "Ignore N items by extension" in Commit dialog
 * Fixed issue #1952: Export specific folder
 * Fixed issue #1002: No right-drag context menu (git copy & add, git move)
 * Fixed issue #1956: Ship more overlay icon sets as TortoiseSVN does
 * Add Ref Compare List in Sync Dialog
 * Fixed issue #1975: Pull Dialog should remember fast forward only
 * Fixed issue #1981: Hotkey to focus on file list in commit dialog
 * Fixed issue #1979: Comments are not stripped from commit message
 * Fixed issue #1991: Disable (by default) certain operations with stash commits
 * Updated shipped libgit2 to version 0.20
 * Fixed issue #2010: Conflict dialog show local and remote commits
 * Autocompletion for language-dependent keywords (usually class/method/variable names) in the commit dialog
 * Fixed issue #2034: Show gravatar in TortoiseGitBlame
 * Fixed issue #871: Blame copy/move detection and other options
 * Fixed issue #1990: TortoiseGitBlame always takes whitespace into account
 * Fixed issue #1988: Allow tag selection in From/To fields instead of dates only
 * Fixed issue #2015: Save and load ref lists (selections) in "Show log" -> "Browse references"
 * Fixed issue #1847: Option to show all local branches in log view
 * Fixed issue #1823: Pressing tab key can insert spaces instead of tab in TortoiseGitMerge
 * Fixed issue #2047: Create a log file with git commands and output
 * Fixed issue #1129: Add Fetch/Pull operations in Show Log window
 * Fixed issue #2048: Add date to stash list / reflog
 * Fixed issue #2049: Add pull to after commit actions
 * Fixed issue #1980: Add Show Unified Diff entry to context menu in TortoiseGitBlame in Revision List
 * Fixed issue #1820: Show Assume valid/unchanged files in repo status dialog on a separate list
 * Fixed issue #1603: Make "Show Whole Project" in log and commit dialog autosaved
 * Fixed issue #827: add the option to autoclose the "Git command progress" window
 * Fixed issue #1913: SVN DCommit Button in successful merge Dialog
 * Fixed issue #1978: Use file directory on Save revision to path in Repository Browser and log dialog
 * Updated libgit to version 1.8.5.2
 * Fixed issue #2059: "Go to line" CLI argument support for diff command

== Bug Fixes ==
 * Fixed issue #1947: When editing git notes, spurious reformatting is done
 * Fixed issue #1958: Revision graph crashes when trying to switch/checkout via context menu
 * Fixed issue #1963: TortoiseGitMerge: Missing color config when an added line is changed
 * Fixed issue #1976: Commit log crashes if it receives a WM_PRINTCLIENT while opening
 * Fixed issue #1974: bugtraq logregex does not save correctly
 * Fixed issue #1977: Commit log: cannot select multiple branches if a branch name matches a filename
 * Fixed issue #1992: Compare selected refs fails if tag object is selected
 * Fixed issue #1985: TortoiseGitBlame does not follow renames when comparing line with previous version
 * Fixed issue #2008: Wrong reflog if hash repeated
 * Fixed issue #2004: In create patch serial dialog, number of commits up down buttons reversed
 * Fixed issue #2013: Double-clicking on ref log list doesn't work until after right-clicking it
 * Fixed issue #2016: Changed files list forgets sort order after switching versions in compare revisions dialog
 * Fixed issue #2014: "Show log" doesn't update properly when a window is dragged over it if aero is not enabled
 * Fixed issue #2021: Disable commit template when combine commits
 * Fixed issue #2024: Unnamed "remote" should not be created
 * Fixed issue #2027: Failed to preserve selected commit when filter is removed
 * Fixed issue #2030: TortoisePlink crash on x64
 * Fixed issue #2037: TortoiseGit.dll sometimes does not close it's handles in explorer.exe
 * Fixed issue #2040: "fatal: pathspec did not match any files" error when resolving deleted/modified conflict
 * Fixed issue #1866: Check for newer version of tgit behind proxy
 * Fixed issue #1927: Clicking on a hyperlinked commit hash leaves the target's log message un-hyperlinked
 * Fixed issue #1835: Question mark icons on committed unchanged files
 * Fixed issue #2053: Can't do "Combine to one commit"; changed file list wrongly empty
 * Fixed issue #2051: Submodule update error when fetchRecurseSubmodules has value on-demand
 * Fixed issue #1860: Race condition in git.exe Progress Dialog
 * Fixed issue #2020: Passworddialog in background after requesting username
 * Fixed issue #1802: submodule update module selection not always accurate
 * Fixed issue #1579: Log Dialog sometimes forgets the dialog height

== Known Issues ==
 * If you upgraded Windows 8 to 8.1 and you experience problems with the installer, please see issue #2061.

= Release 1.8.6.0 =
Released: 2013-10-20

== Features ==
 * Revision Graph: Can generate output graph file through command line
 * Fixed issue #1858: Switch-and-merge as a single command
 * Log Dialog: Support Gravatar
 * Implement git checkout --merge
 * TortoiseGitIDiff: Conflict resolving for images
 * Fixed issue #1795: Allow to put branch labels on right side of message column in log view
 * Fixed issue #1870: Commit subset of changes selected from diff dialog
 * Fixed issue #1785: If PuTTY defaults to anything other than type SSH port 22, TortoiseGit acts up on SSH cloning (fixed in TortoiseGitPlink.exe)
 * Add setting to confirm to kill running git process in progress dialog
 * Added support for tgit://-links to start cloning from browser (e.g. tgit://clone/https://code.google.com/p/tortoisegit/)
 * Added optional support for git://-links to start cloning from browser
 * Added optional support for smartgit:// and github-windows://-links to start cloning from browser
   In order to be able to use github-windows://-links on github.com web page, you have to enable them for your GitHub profile once.
   Right now the only way is to install the official GitHub client and sign in with your GitHub profile (on any Windows machine).
 * Allow to edit hierarchical git settings
   If you have set "i18n.commitencoding" to something different than UTF-8 check your "user.name" setting
 * Fixed issue #1645: enable/disable spell checking in commit dialog
 * Fixed issue #1806: Compressed graph in the log view
 * Fixed issue #1926: Add "No Merges" checkbox in Log Messages window
 * Fixed issue #1779: tortoisegit does not understand include.path in global config
   If you have relevant settings for TGitCache in an included file, you have to restard TGitCache or modify the global, system, or local config file in order to reload any included file.
 * Support project icon as task button overlay
 * Fixed issue #1946: In "Compare revisions", please show something to confirm when there are no differences

== Bug Fixes ==
 * Fixed issue #1859: Log too long when using Switch to New Branch option in Create Branch dialog
 * Fixed issue #1864: Commit button did not work after revert
 * Fixed issue #1862: Some labels not wide enough for translations to fit in
 * Fixed issue #1790: "Clean up" window position is not preserved on multi-monitor setup
 * Fixed issue #1876: Up/down buttons in Rebase dialog desynchronise the bottom view
 * Fixed issue #1875: Commit selection is lost with focus in Rebase dialog
 * Fixed issue #1873: Squash doesn't preserve original author date
 * Fixed issue #1863: never-ending wait due to lost messages
 * Fixed issue #1883: Option Buttons in Hook script not wide enough
 * Fixed issue #1893: Unified diff for merge commit always shows inverted changes
 * Fixed issue #1896: Switch/Checkout Branch name resets itself after browsing for a branch
 * Fixed issue #1895: Context menu incomplete if working tree is located on network share
 * Fixed issue #1618: In "Show log", mouseover triggers improper redraw of ClearType font log descriptions in "Message" column
 * Fixed issue #1891: Cleanup dialog unexpectedly sizable
 * Bring back templates when creating repository with libgit2, it was "cancelled" in since TortoiseGit 1.8.0
 * Fixed issue #1908: "Export selection to.." fails to checkout files which names (or paths) renamed in working dir
 * Fixed issue #1914: Repository Browser give an error (libgit2) after change branch
 * Fixed issue #1915: Submodule Update Dialog behaves curious
 * Fixed issue #1919: Submodule visibility with square brackets
 * Fixed issue #1918: Settings dialog forces to use remotes
 * Fixed issue #1923: Once Credential node is activated, pressing apply button in Settings dialog will close the dialog
 * Fixed issue #1769: "Show Log" missing from context menu if "Shell Extended" and a file was Added but not committed
 * Fixed issue #1917: Avoid request to stash if there is nothing to rebase or fast forward is possible
 * Fixed issue #1929: Using "Find" in "Show log" doesn't move to commits it finds, it only selects them
 * Fixed issue #1948: Case sensitive authors switch throw an error

== Known Issues ==
 * If you experience problems with PuTTY ssh, please see issue #1880.

= Release 1.8.5.0 =
Released: 2013-08-18

== Features ==
 * Fixed issue #1831: Allow Origin Remote Renaming on Clone
 * Fixed issue #1839: Conflict dialog does not allow resolving multiple or all conflicts with the same option
 * Allow to send (patch)mails over relay servers (e.g. the one from your ISP)
 * When adding second and more remotes, prompt user to disable tag fetching to avoid fetching wrong tags
 * Fixed issue #1845: Add "pull" button on "git switch" window
 * Fixed issue #1848: TortoiseGitBlame doesn't scroll to the previously selected line on "Blame previous revision"
 * Underline git hash in log message view and jump to that commit when clicking on the hash
 * Fixed issue #1829: You have not concluded your merge (MERGE_HEAD exists) - allow to abort merge more easily.
 * Commit Dialog: Add "Pick commit hash" in message text box context menu
 * Can set log graph line width and node size
 * Updated shipped PuTTY Plink to version 0.63 (which contains some security fixes)
 * Fixed issue #1746: Pressing "Delete" on keyboard should delete selected non versioned file in commit dialog
 * Sync Dialog: Add stash menu button
 * Fixed issue #1852: Add command-line argument to tortoisegitproc that specifies value for Directory field

== Bug Fixes ==
 * Fixed issue #1833: Fast-Forward rebase does not preserve SHA-1 of commits
 * Fixed issue #1832: TortoiseGitMerge has an empty menue when German language pack is loaded
 * Fixed issue #497: TGitCache.exe won't let user delete folder
 * Mitigated issue #1011: "git svn" commands create "sys$command" file

= Release 1.8.4.0 =
Released: 2013-07-09

== Features ==
 * Fixed issue #1765: Pull button when push (after commit) fails
 * Updated shipped libgit2 to version 0.19
 * Updated libgit to version 1.8.3
 * Support diff.context config key
 * Fixed issue #1778: Add Submodule with Putty key
 * Fixed issue #1800: Automatically remove "git clone " from URL in Clone dialog
 * Fixed issue #1807: Handle new descriptions of detached head introduced in git 1.8.3
 * TortoiseGitMerge: Encoding and EOL conversion
 * TortoiseGitMerge: Tab / spaces conversion and trim trailing space
 * TortoiseUDiff: Add Printing function
 * Fixed issue #553: Pull the latest version of all submodules
 * TortoiseGitMerge: Improved applying a patch with conflicts
 * Rename touch.exe as tgittouch.exe to avoid filename collision
 * Support SOCKS proxy
 * Include submodules in RepositoryBrowser

== Bug Fixes ==
 * Fixed issue #1763: Unable to re-download TortoiseGit packages due to caching
 * Fixed issue #795: Switch/Checkout Dialog, "Switch To Version" is confusing
 * Fixed issue #722: Pull/Push sometimes does not gets the right remote branch
 * Fixed issue #1781: Sync dialog fails with "Encountered an improper argument" when closing log tab with escape
 * Fixed issue #1773: "Show changes as unified diff" on "Working dir changes" show inverted diff operation
 * Fixed issue #1753: On dialog box for SSH certificate's passphrase, some certificate filenames aren't fully displayed
 * Fixed issue #1726: Rebasing issues with empty commits
 * Fixed issue #1782: Do not reset changed lines/files statistics after toggling "Authors case sensitive" checkbox
 * Fixed issue #1783: TortoiseGit does not work on WinXP/2003 x64
 * Fixed issue #1798: "Paste Recent commits" during Please wait in Commit dialog does not work
 * Fixed issue #1106: Stairs in log view
 * Fixed issue #1304: TortoiseGit doesn't see a bare repo within a non-bare one
 * "Delete (keep local)" did not work on folders
 * Fixed issue #1756: Rebase trips over merge commits
 * Fixed possible crashes while applying a patch in TortoiseGitMerge
 * Fixed issue #1809: Overlay shows changes in parent folder if a file with a second extension exists
 * TortoiseGitMerge: Fixed bugs regarding multi-view edit
 * Fixed issue #1814: Squash rebase fills message too much
 * Reverting newly added file in Commit-dialog misbehaving
 * Fixed issue #1589: Clone Dialog's URL case sensitivity causes issues with folder creation
 * Fixed issue #1786: Committing 25 or more files causes hidden progress dialog
 * Fixed issue #1732: Tortoisegit always crashes when viewing the history log of blink
 * Fixed issue #1824: Rebase Dialog sometimes not showing after running Fetch and Rebase in Sync Dialog
 * Fixed issue #1725: 'Git Show Log' doesn't work on folders created by git-new-workdir script

= Release 1.8.3.0 =
Released: 2013-05-05

== Features ==
 * Press F5 can refresh Submodule Diff Dialog
 * Fixed issue #1359: Drag support for files listed as being changed in the commit/log/modifications window
 * log list: indicate annotated tag in tag shape
 * TortoiseGitBlame: Allow to highlight lines by age of last modification
 * Fixed issue #1376: Daemon starting from Tortoise UI
 * Fixed issue #1737: Make a button to rename remote
 * Repository Browser: Allow to copy tree / blob hashes to clipboard
 * Added sound support for indicating warnings and errors
 * Fixed issue #1755: Add "Remove All" and "Ignore All" options in Remove from Index Prompt
 * Fixed issue #1747: Add interface to log window to view range log

== Bug Fixes ==
 * Fixed issue #1729: crash when commit
 * Fixed issue #1728: TortoiseGitMerge show fake difference in the same lines if line end falls to 0x40000 byte
 * Fixed issue #1741: Push / Pull Dialog URL combo box should not be filled unless enabled
 * Fixed issue #1735: diff-xls.vbs not found
 * Fixed issue #1750: Repository Browser fails for empty repository
 * Fixed issue #1743: Remove "The target folder is not empty!" warning
 * Fixed issue #1757: Compare single new file against working tree
 * Fixed issue #1760: Unified diff of two revisions is inversed
 * Fixed various possible crashes

= Release 1.8.2.0 =
Released: 2013-03-26

== Features ==
 * Fixed issue #1270: Log dialog can revert selected files to parent revision
 * Fixed issue #1500: Support git merge --log option
 * Can disable log cache (tortoisegit.data, tortoisegit.index)
 * Revision Graph can save as graphviz dot language (*.gv)
 * Support merge strategies except octopus
 * Fixed issue #1597: Reduce chance of committing old submodule revision on cherry-pick / rebase conflicts
 * Can specify specific paths of submodules to update
 * Fixed issue #1661: TortoiseGitBlame: show line date time
 * Fixed issue #1662: skip-worktree should not be exposed via context menus or anything without confirmation
 * Fixed issue #330: Implement --author option gui interface in the commit dialog
 * Fixed issue #1147: Ability to filter out branches in Log dialog
 * Fixed issue #1628: Support commit ranges in log list (from Reference Browser)
 * Fixed issue #832: Compare commits between branches (branch1...branch2, from Reference Browser)
 * Fixed issue #515: Sort the log window by date
 * Fixed issue #1676: Automatically check "Make it Bare" when repository path ends in ".git"
 * Fixed issue #1677: Clicking "revert" on a file should automatically check the file in the revert dialog
 * Fixed issue #1667: Ability to ignore a folder in commit dialog
 * Fixed issue #1674: Option "Push all branches" leaves out tags on pushed changes
 * Fixed issue #1663: F5 does not refresh the revision graph
 * Fixed issue #522: Store password for HTTP
 * Fixed issue #1660: Save Push Dialog "Push all branches" and "Use Thin Pack" options
 * Fixed issue #1542: Can send pull request email
 * Fixed issue #1493: Remember Push Dialog "Push to all remotes" option state
 * Enhanced Windows 7 taskbar grouping and highlighting of windows belonging to the same working tree
 * .mailmap is now used for Log-Dialog Statistics
 * Fixed issue #1610: Average values on statistics dialog graph
 * Fixed issue #1708: Merge dialog have no saving of log message
 * Fixed issue #1716: TortoiseGitBlame added line parameter
 * Allow to set a default value for ssh client in HKLM (Software\TortoiseGit\SSH)

== Bug Fixes ==
 * Fixed issue #1642: Incorrect behavior if repo is located on root of drive
 * Fixed issue #1643: TortoiseGitMerge window do not maximize correctly on screeen with right-side docked start bar
 * Fixed issue #1639: Does not work on older CPU without SSE2
 * Fixed issue #1682: Rebase ignores commits after an error is received
 * Fixed issue #1429: Blame: copy sha to clipboard copies the log message
 * Fixed issue #1654: Git blame commit message tooltip flashes when tooltip window is tall
 * Fixed issue #1658: Checkbox 'add "cherry picked from"' has wrong anchor
 * Fixed issue #1657: Dirty submodule commit does not open the underling submodule commit dialog
 * Fixed issue #1552: TGitCache prevents a git clone from performing successfully
 * Fixed issue #1631: Set focus to branch menu in Switch/Checkout window
 * Fixed issue #1646: TortoiseGit Log gives undeterministic results (log does not apply --boundary any more by default)
 * Fixed issue #1085: Small commit with lots of unversioned and not ignored files takes very long
 * Fixed issue #1675: delete/ignore does not delete folder from repo when local copy is kept
 * Fixed issue #1679: Reset dialog pick another revision has no effect
 * Fixed issue #1609: remember my remote branch choice precisely
 * Fixed issue #1268: Paths in Windows Explorer changed to all lower case
 * Fixed issue #1681: High screen DPI breaks TortoiseGitMerge's ribbon UI sprites
 * Fixed issue #1685: Deleting remote branch blocks UI
 * Fixed issue #1686: Wrong stash list after "Stash Apply" in RefLog
 * Fixed issue #1689: Option to make Git Commit GUI look different from TortoiseSVN equivalent
 * Fixed issue #1693: Cherry pick progress bar doesn't stay green
 * Fixed issue #1276: Cannot show diff of renamed file
 * Fixed issue #1696: Fetch from switch dialog does not refresh branches list
 * Fixed issue #1701: Changing commit order in rebase dialog doesn't auto scroll
 * Fixed issue #1702: Original commit message is showen even though it is changed during rebase
 * Fixed issue #1223: Workaround endless waiting when git.exe already exited
 * Fixed issue #1709: Right click -> assume unchanged is irreversible
 * Fixed issue #1713: Pre-populate commit message on squash merges
 * Fixed issue #1566: Frequent crashes when searching log

= Release 1.8.1.0 =
Released: 2013-02-07

== Features ==
 * Fixed issue #1623: Search by email in Log window
 * Fixed issue #1624: Easier navigation in revision graph with mouse

== Bug Fixes ==
 * Fixed issue #1611: Changing Search criteria with empty search field refreshes log content
 * Fixed issue #1620: Apply Patch serial can't open file dialog on WinXP
 * Fixed issue #1533: Could not parse git.exe version number
 * Fixed issue #1619: TortoiseGitMerge: Ribbon UI/toolbars can be toggled
 * Fixed issue #1627: TortoiseGit gets the wrong revision if the branch name looks like git-describe format
 * Fixed issue #1617: TortoiseGitPlink does not work with interactive ssh logins
 * Fixed issue #1384: Commit Dialog autocompletion does not work for some pattern

= Release 1.8.0.0 =
Released: 2013-01-27

== Features ==
 * Fixed issue #1377: Log Dialog Working dir changes should include untracked files
 * Fixed issue #1541: Show progress dialog when running git request-pull
 * Fixed issue #1513: Easier to clean TortoiseGit temporary files
 * Fixed issue #1540: Add jump to previous / next commit in Log Dialog
 * Fixed issue #1529: Can show and set tagopt
 * Fixed issue #1554: Unwanted text formatting in commit dialogue (styling can be disabled using advanced settings now)
 * Fixed issue #1563: Show repository dir on Settings Dialog title bar
 * Fixed issue #1577: Add a retry button on Reset failure
 * Fixed issue #1571: Warn author not set when editing notes
 * Fixed issue #221: After resolving all merge conflicts, it's not obvious the project needs a commit
 * Fixed issue #1568: Add support for recurse-submodules on push dialog
 * Fixed issue #1578: Warn author not set when merging
 * Fixed issue #1557: Submodule Diff Dialog should launch diff with working copy if the submodule is dirty
 * Fixed issue #1066: Add 'Revision Graph' Feature
 * Fixed issue #1435: EXE Name collision with TortoiseSVN
   Renamed:
   - TortoiseIDiff.exe to TortoiseGitIDiff.exe
   - TortoiseMerge.exe to TortoiseGitMerge.exe
   - TortoiseProc.exe to TortoiseGitProc.exe
   - TortoisePlink.exe to TortoiseGitPlink.exe (TortoisePlink.exe is still shipped for compatibility reasons)
   - TortoiseUDiff.exe to TortoiseGitUDiff.exe
 * Fixed issue #1433: Can reset to remote tracking branch after fetch
 * Fixed issue #763: "Clean up" should show a list of to-be-deleted files
 * Fixed issue #1581: Show/Hide tags in the log
 * Synced TortoiseGitMerge code with TortoiseMerge of TortoiseSVN code (trunk)
 * Log Dialog specially highlights branches that have a remote tracking branch
 * Added search mechanism to reflog dialog
 * Add No fetch, Merge and Rebase options in Submodule Update Dialog
 * Fixed issue #1467: put remote branches at the bottom in "branches" dropdowns (can be disabled using advanced settings)
 * Fixed issue #1285: Show Log Filter on Tags
 * Uncheck "Track" checkbox when creating a branch with different name to remote branch
 * Add button to push notes in Sync Dialog

== Bug Fixes ==
 * Fixed issue #1535: Unclear UI in prompt dialog of Stash Save
 * Fixed issue #1538: Deleting multiple stash list entries skips some and delete the wrong ones
 * Fixed issue #1543: TortoiseGit Comboboxes trim input if longer than their width
 * Fixed issue #1544: TortoiseGit Init warning message is not appropriate
 * Fixed issue #1555: Commit dialog fails to warn submodule dirty state
 * Fixed issue #1556: Narrower treeview when launching Settings Dialog with default page Remote
 * Fixed issue #1383: Pageant is not always auto-loaded if using sync remote update (some without keys)
 * Fixed issue #1536: Committing via log causes hidden progress dialog
 * Fixed issue #1593: Sync dialog In ChangeList shows wrong diff when pressing enter

In order to find the list of changes for releases before 1.8.0, please refer to Changelog-pre1.8.txt
